{"swagger":"2.0","info":{"description":"These are 3DS Issuer Services.\n","version":"2.2.0","title":"3DS Issuer Services"},"schemes":["https","http"],"basePath":"/3ds-issuer-services","paths":{"/authentications":{"post":{"summary":"Call a new authentication attempt to ACS","operationId":"JSON Risk","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"body","name":"body","description":"Authentication object that contains all needed data for creating a new authentication attempt and making risk analysis","required":true,"schema":{"$ref":"#/definitions/Authentication"}}],"responses":{"201":{"description":"The authentication request was successfully received","schema":{"type":"object","required":["authenticationId","authenticationStatus"],"properties":{"authenticationId":{"type":"string","description":"An id identifying an authentication request","minLength":36,"maxLength":36,"example":"17b9946c-3a81-11e9-b210-d663bd873d93"},"authenticationStatus":{"type":"string","enum":["Y","N","C","R","U"],"description":"Indicates whether a transaction qualifies as an authenticated transaction or account verification.","example":"Y(Authentication/ Account Verification Successful) N(Not Authenticated /Account Not Verified; Transaction denied) C(Challenge Required; Additional authentication is required using the CReq/CRes) R(Account Verification Rejected; Issuer is rejecting authentication/verification and request that authorisation not be attempted) U(Authentication/ Account Verification Could Not Be Performed; Technical or other problem, as indicated in ARes or RReq)"},"challengeInfo":{"type":"array","items":{"$ref":"#/definitions/Step"},"description":"Authentication steps"},"authenticationStatusReasonCode":{"type":"string","description":"Provides a codified information on why the authenticationStatus field has the specified value. The full list of reason codes should map the possible authentication outcomes. This property will be present only when 'authenticationStatus' is set to 'N' or 'R'.","example":"CARDHOLDER_NOT_ENROLLED,PAN_NOT_FOUND,EXPIRED_CARD,INVALID_CARD_NUMBER,STOLEN_CARD"},"authenticationStatusReasonDescription":{"type":"string","description":"Provides a detailed information on why the authenticationStatus field has the specified value. This property will be present only when 'authenticationStatus' is set to 'N' or 'R'.","example":"The given PAN was not found"}}}},"400":{"description":"The client request cannot be completed successfully (e.g. a mandatory parameter is missing).\nThe client should submit a new valid request. See the response body for a more detailed error description.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nACS shall map back this error as a `U` response to the upstream payment gateway.\n","schema":{"$ref":"#/definitions/Error"}},"504":{"description":"The server did not receive a timely response from an upstream server it accessed to deal with your HTTP request.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}}}}},"/authentications/{authenticationId}/otp":{"post":{"summary":"Creates a new OTP authentication flow","operationId":"Start OTP","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"body","name":"body","required":true,"schema":{"type":"object","properties":{"acsTransactionID":{"type":"string","minLength":36,"maxLength":36,"description":"ACS Transaction Id","example":"dfb11efb-9780-439f-a54e-90cce52b7d33"},"step":{"type":"integer","description":"The current step number in the actual authentication flow","example":"1"}}}}],"responses":{"201":{"description":"The OTP code was successfully sent to the cardholder","schema":{"type":"object","properties":{"userInterfaceInformation":{"type":"array","items":{"$ref":"#/definitions/UserInterfaceInformation"}}}}},"400":{"description":"The client request cannot be completed successfully\n(e.g. no more attempts available to the cardholder, cardholder account locked, a mandatory parameter is missing, ...).\nThe client should submit a new valid request. See the response body for a more detailed error description.\nThis attempt will consume the available attempts counter.\n","schema":{"$ref":"#/definitions/Error"}},"404":{"description":"The client used an authentication id that the server cannot found\nSee the response body for a more detailed error description.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}},"504":{"description":"The server did not receive a timely response from an upstream server it accessed to deal with your HTTP request.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}}}}},"/authentications/{authenticationId}/otp/attempts":{"post":{"summary":"Attempts to validate an OTP code","operationId":"Check OTP","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"body","name":"body","required":true,"schema":{"type":"object","required":["otpCode","acsTransactionID"],"properties":{"attemptCount":{"type":"integer","minimum":1},"otpCode":{"type":"string","example":"123456"},"pin":{"type":"string","example":"6789","description":"an additional personal code to provide for some authentication use cases (e.g. OTP via SMS)"},"acsTransactionID":{"type":"string","minLength":36,"maxLength":36,"description":"ACS Transaction Id","example":"anyACSTransactionId12312312312312312"},"step":{"type":"integer","description":"The current step number in the actual authentication flow","example":"1"}}}}],"responses":{"201":{"description":"The code submitted by the client matches the expected OTP value"},"400":{"description":"The client request cannot be completed successfully\n(e.g. wrong OTP code submitted, no more attempts available to the cardholder, cardholder account locked, a mandatory parameter is missing, ...).\nThe client should submit a new valid request. See the response body for a more detailed error description.\nThis attempt will consume the available attempts counter.\n","schema":{"$ref":"#/definitions/Error"}},"404":{"description":"The given pair authenticationId and acsTransactionID cannot be found in the server.\nThis attempt should not consume the available attempts counter.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}},"504":{"description":"The server did not receive a timely response from an upstream server it accessed to deal with your HTTP request.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}}}}},"/authentications/{authenticationId}/oob":{"post":{"summary":"Creates a new OOB challenge authentication flow.\nThis means that an attempt to authenticate the cardholder is started out-of-band,\nand a call to the next API should be performed when the client wants to check whether the authentication has been completed successfully.\n","operationId":"Start OOB","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"body","name":"body","required":true,"schema":{"type":"object","required":["acsTransactionID"],"properties":{"acsTransactionID":{"type":"string","minLength":36,"maxLength":36,"description":"ACS Transaction Id","example":"anyACSTransactionId12312312312312312"},"step":{"type":"integer","description":"The current step number in the actual authentication flow","example":"1"}}}}],"responses":{"201":{"description":"The OOB challenge authentication flow has been started successfully.\nThis means that the cardholder will receive further information out-of-band on how to confirm his/her identity.\nFor example, a push notification has been sent to the cardholder's banking app in order to prove his/her identity.\n","schema":{"type":"object","properties":{"userInterfaceInformation":{"type":"array","items":{"$ref":"#/definitions/UserInterfaceInformation"}}}}},"400":{"description":"The client request cannot be completed successfully\n(e.g. no more attempts available to the cardholder, cardholder account locked, a mandatory parameter is missing, ...).\nThe client should submit a new valid request. See the response body for a more detailed error description.\nThis attempt will consume the available attempts counter.\n","schema":{"$ref":"#/definitions/Error"}},"404":{"description":"The client used an authentication id that the server cannot found\nSee the response body for a more detailed error description.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}},"504":{"description":"The server did not receive a timely response from an upstream server it accessed to deal with your HTTP request.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}}}}},"/authentications/{authenticationId}/oob/attempts":{"post":{"summary":"Creates a new verification attempt, to check whether the cardholder confirm successfully his/her identity\nwith an out-of-band challenge mechanism.\nFor example, the cardholder completed the authentication inside the banking app.\n","operationId":"Check OOB","consumes":["application/json"],"produces":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"body","name":"body","required":true,"schema":{"type":"object","required":["acsTransactionID"],"properties":{"attemptCount":{"type":"integer","minimum":1},"acsTransactionID":{"type":"string","minLength":36,"maxLength":36,"description":"ACS Transaction Id","example":"anyACSTransactionId12312312312312312"},"step":{"type":"integer","description":"The current step number in the actual authentication flow","example":"1"}}}}],"responses":{"201":{"description":"The verification attempt has been created, meaning that\nthe cardholder confirmed successfully his/her identity using the OOB challenge mechanism triggered.\n"},"400":{"description":"Bad Request.\nThe client request cannot be completed successfully\n(e.g. cardholder deny his/her identity, no more challenge attempts available to the cardholder, cardholder account locked, a mandatory parameter is missing, ...).\nSee the response body for a more detailed error description.\nDepending on the error details, the client should (or should not) submit a new valid request.\nThis attempt will consume the cardholder available challenge attempts counter.\n","schema":{"$ref":"#/definitions/Error"}},"404":{"description":"The given pair authenticationId and acsTransactionID cannot be found in the server.\nThis attempt should not consume the available attempts counter.\n","schema":{"$ref":"#/definitions/Error"}},"412":{"description":"Precondition Failed: The server cannot create a successful authentication attempt,\nbecause the cardholder still did not complete the authentication process on the out-of-band challenge mechanism.\nThis attempt will consume the cardholder available challenge attempts counter.\nThe client should wait for another cardholder confirmation before submitting a new request.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}},"504":{"description":"The server did not receive a timely response from an upstream server it accessed to deal with your HTTP request.\nThis attempt does not consume the available attempts counter.\nThe client can submit again a new request.\n","schema":{"$ref":"#/definitions/Error"}}}}},"/authentications/{authenticationId}/status":{"post":{"summary":"Receive the final status of the transaction (in both an OTP or OOB authentication flow).\nUseful when e.g. the transaction has been cancelled by the cardholder. It produces no response.\n","operationId":"Notify Transaction","consumes":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"body","name":"body","required":true,"schema":{"type":"object","required":["acsTransactionID"],"properties":{"acsTransactionID":{"type":"string","minLength":36,"maxLength":36,"description":"ACS Transaction Id","example":"anyACSTransactionId12312312312312312"},"transactionFinalStatus":{"type":"string","enum":["F","E"],"description":"The transaction completion status","example":"F=completed, E=not completed"},"eci":{"type":"string","description":"Electronic Commerce Indicator (ECI) of the transaction","example":"05"},"cavv":{"type":"string","description":"Cardholder Authentication Verification Value (CAVV) of the transaction","example":"ABC123"},"rreq":{"type":"object","description":"the RREQ message related to this transaction","properties":{"authenticationMethod":{"type":"string","enum":["01","02","03","04","05","06","07","08","09","10"],"description":"Authentication approach that the ACS used to authenticate the Cardholder for this specific transaction","example":"01=Static Passcode, 02=SMSOTP, 03=KeyfoborEMV card reader OTP, 04=AppOTP, 05 = OTP Other, 06=KBA, 07 = OOB Biometrics, 08 = OOB Login, 09 = OOB Other, 10 = Other"},"authenticationType":{"type":"string","enum":["01","02","03"],"description":"Indicates the type of authentication method the Issuer will use to challenge the Cardholder, whether in the ARes message or what was used by the ACS when in the RReq message.","example":"01=Static 02=Dynamic 03=OOB"},"authenticationValue":{"type":"string","description":"Payment System- specific value provided as part of the ACS registration for each supported DS.","example":"AAIBAjlkAhVAMJKDiWQCAAAAAAA="},"challengeCancel":{"type":"string","enum":["01","02","03","04","05","06","07"],"description":"Indicator informing the ACS and the DS that the authentication has been cancelled","example":"01 = Cardholder selected Cancel, 02 = 3DS Requestor cancelled Authentication, 03 = Transaction Abandoned, 04 = Transaction Timed Out at ACS- other timeouts, 05 = Transaction Timed Out at ACS— First CReq not received by ACS, 06 = Transaction Error, 07 = Unknown"},"eci":{"type":"string","description":"Electronic Commerce Indicator (ECI) of the transaction","example":"05"},"transStatus":{"type":"string","enum":["Y","N","U","A","C","R"],"description":"Indicates whether a transaction qualifies as an authenticated transaction or account verification.","example":"Y = Authentication/ Account Verification Successful, N = Not Authenticated /Account Not Verified; Transaction denied, U = Authentication/ Account Verification Could Not Be Performed; Technical or other problem, as indicated in ARes or RReq, A = Attempts Processing Performed; Not Authenticated/Verified , but a proof of attempted authentication/verificat ion is provided, C = Challenge Required; Additional authentication is required using the CReq/CRes, R = Authentication/ Account Verification Rejected; Issuer is rejecting authentication/verificat ion and request that authorisation not be attempted."},"transStatusReason":{"type":"string","enum":["01","02","03","04","05","06","07","08","09","10","11","12","13","14","15","16","17","18","19","20","21"],"description":"AProvides information on why the Transaction Status field has the specified value.","example":"01 = Card authentication failed, 02 = Unknown Device, 03 = Unsupported Device, 04 = Exceeds authentication frequency limit, 05 = Expired card, 06 = Invalid card number, 07 = Invalid transaction, 08 = No Card record, 09 = Security failure, 10 = Stolen card, 11 = Suspected fraud, 12 = Transaction not permitted to cardholder, 13 = Cardholder not enrolled in service, 14 = Transaction timed out at the ACS, 15 = Low confidence, 16 = Medium confidence, 17 = High confidence, 18 = Very High confidence, 19 = Exceeds ACS maximum challenges, 20 = Non-Payment transaction not supported, 21 = 3RI transaction not supported"},"threeDSServerTransID":{"type":"string","description":"Universally unique transaction identifier assigned by the 3DS Server to identify a single transaction.","example":"bb59e90f-e866-40ef-858b-910f5fb44226"},"acsTransID":{"type":"string","description":"Universally Unique transaction identifier assigned by the ACS to identify a single transaction.","example":"bb59e90f-e866-40ef-858b-910f5fb44226"},"dsTransID":{"type":"string","description":"Universally unique transaction identifier assigned by the DS to identify a single transaction.","example":"bb59e90f-e866-40ef-858b-910f5fb44226"},"interactionCounter":{"type":"string","description":"Indicates the number of authentication cycles attempted by the Cardholder.","example":"42"},"messageCategory":{"type":"string","enum":["01","02"],"description":"Identifies the category of the message for a specific use case.","example":"01=PA, 02=NPA"},"messageVersion":{"type":"string","description":"Protocol version identifier. This shall be the Protocol Version Number of the specification utilised by the system creating this message.","example":"2.1.0"}}}}}}],"responses":{"204":{"description":"No Content."}}}},"/choices/{authenticationId}/{choiceCode}":{"get":{"summary":"Retrieve all the choices available for the give authentication flow","operationId":"Initialize authentication choice selection","produces":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"path","name":"choiceCode","required":true,"type":"string","description":"A code that describe an authentication scenario where a user choice is needed."}],"responses":{"200":{"description":"A list of choice to be presented to the user","schema":{"type":"object","properties":{"choiceCode":{"type":"string","description":"the choice code sent in the request"},"choices":{"type":"array","items":{"$ref":"#/definitions/UserInterfaceInformation"},"description":"a list of key-value choices to be rendered in the UI"}}}},"400":{"description":"The client request cannot be completed successfully (e.g. a mandatory parameter is missing).\nThe client should submit a new valid request. See the response body for a more detailed error description.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nACS shall map back this error as a `U` response to the upstream payment gateway.\n","schema":{"$ref":"#/definitions/Error"}}}}},"/choices/{authenticationId}/{choiceCode}/{selectedChoice}":{"post":{"summary":"ask to start a new authentication flow for the given choice","operationId":"Ask to start a new authentication","produces":["application/json"],"parameters":[{"in":"path","name":"authenticationId","required":true,"type":"string","description":"An id identifying an authentication request, generated by the 3DS Issuer Service"},{"in":"path","name":"choiceCode","required":true,"type":"string","description":"A code that describe an authentication scenario where a user choice is needed."},{"in":"path","name":"selectedChoice","required":true,"type":"string","description":"The actual selection made by the user."}],"responses":{"201":{"description":"The authentication request was successfully received","schema":{"type":"object","required":["challengeInfo"],"properties":{"challengeInfo":{"type":"array","items":{"$ref":"#/definitions/Step"},"description":"New authentication steps for the given choice"}}}},"400":{"description":"The client request cannot be completed successfully (e.g. a mandatory parameter is missing).\nThe client should submit a new valid request. See the response body for a more detailed error description.\n","schema":{"$ref":"#/definitions/Error"}},"500":{"description":"Generic internal server error (due to our's or downstream services).\nSee the response body for a more detailed error description.\nACS shall map back this error as a `U` response to the upstream payment gateway.\n","schema":{"$ref":"#/definitions/Error"}}}}}},"definitions":{"Error":{"type":"object","properties":{"errorCode":{"type":"string","description":"Provides a codified information on why the request failed.","example":"INTERNAL_ERROR,MANDATORY_PARAMETER_MISSING,UNKNOWN_AUTHENTICATION_ID,CANNOT_SEND_OTP,CANNOT_SEND_OOB,INCORRECT_OTP,PENDING_OOB,CANNOT_VERIFY_OTP,FAILED_OOB,EXPIRED_OTP"},"errorDescription":{"type":"string","example":"Verbose, plain language description of the problem. Provide developers suggestions about how to solve their problems here"},"userMessage":{"type":"string","example":"This is a message that can be passed along to end-users, if needed."},"challengeInfo":{"type":"array","items":{"$ref":"#/definitions/Step"},"description":"Offer other authentication alternatives to the user."},"userInterfaceInformation":{"type":"array","items":{"$ref":"#/definitions/UserInterfaceInformation"}}}},"Authentication":{"type":"object","required":["threeDSServerTransID","deviceChannel","messageCategory","areq","issuerId"],"properties":{"issuerId":{"type":"string","description":"Unique identifier of issuer"},"areq":{"type":"object","description":"the raw AReq JSON payload as received by the upstream ACS2 system"},"threeDSMethodCompletationIndicator":{"type":"string","enum":["Y","N","U"],"description":"(aka threeDSCompInd in EMVCo specifications) Indicates whether the 3DS Method successfully completed. Y(Successfully completed) N(Did not successfully complete) U(Unavailable— 3DS Method URL was not present in the PRes message data for the card range associated with the Cardholder Account Number)","example":"Y"},"threeDSRequestor":{"$ref":"#/definitions/ThreeDSRequestor"},"threeDSServerTransID":{"type":"string","description":"3DS Server Transaction Id","minLength":36,"maxLength":36,"example":"728f0395-f26b-464e-8901-beck728d5ef9"},"threeRIIndicator":{"type":"string","enum":["01","02","03","04","05"],"description":"3RI request type. 01(Recurring transaction) 02(Instalment transaction) 03(Add card) 04(Maintain card information) 05(Account verification)","example":"01"},"acquirerBIN":{"type":"string","maxLength":11,"description":"Acquiring institution identification code as assigned by the DS receiving the AReq message"},"acquirerMerchantID":{"type":"string","maxLength":35,"description":"Acquirer-assigned Merchant identifier"},"addressMatch":{"type":"string","enum":["Y","N"],"description":"Indicates whether the Cardholder Shipping Address and Cardholder Billing Address are the same. Y(Shipping Address matches Billing Address) N(Shipping Address does not match Billing Address)","example":"Y"},"browserIP":{"type":"string","maxLength":45,"description":"IP address of the browser as returned by the HTTP headers to the 3DS Requestor."},"cardHolderAccountInfo":{"$ref":"#/definitions/CardHolderAccountInfo"},"card":{"$ref":"#/definitions/PlainCard"},"buyer":{"$ref":"#/definitions/CardHolder"},"deviceChannel":{"type":"string","enum":["01","02","03"],"description":"Indicates the type of account. 01(App-based APP) 02(Browser BRW) 03(3DS Requestor Initiated 3RI)","example":"02"},"deviceInfo":{"type":"string","description":"Device information gathered by the 3DS SDK from a Consumer Device. This is JSON name/value pairs that as a whole is Base64url encoded."},"purchaseInstalData":{"type":"integer","description":"Indicates the maximum number of authorisations permitted for instalment payments","minLength":1,"maxLength":3},"merchant":{"$ref":"#/definitions/Merchant"},"messageCategory":{"type":"string","enum":["01","02"],"description":"Identifies the category of the message for a specific use case 01(Payment) 02(Not Payment)","example":"01"},"purchase":{"$ref":"#/definitions/Purchase"},"recurringExpiryDate":{"type":"string","format":"date","description":"(aka recurringExpiry in EMVCo specifications) Date after which no further authorisations shall be performed","example":"2019-11-19"},"recurringFrequency":{"type":"integer","minLength":1,"maxLength":4,"description":"Indicates the minimum number of days between authorisations","example":24},"transactionType":{"type":"string","enum":["01","03","10","11","28"],"description":"(aka transType in EMVCo specifications) Identifies the type of transaction being authenticated. 01(Goods/Service Purchase) 03(Check Acceptance) 10(Account Funding) 11(Quasi-Cash Transaction) 28(Prepaid Activation and Load)","example":"01"}}},"ThreeDSRequestor":{"type":"object","properties":{"authenticationIndicator":{"type":"string","enum":["01","02","03","04","05","06"],"description":"(aka threeDSRequestorAuthenticationInd in EMVCo specification) Indicates the type of Authentication request 01(Payment transaction) 02(Recurring transaction) 03(Instalment transaction) 04(Add card) 05(Maintain card) 06(Cardholder verification)","example":"01"},"authenticationInfo":{"$ref":"#/definitions/ThreeDSRequestorAuthenticationInfo"},"challengeIndicator":{"type":"string","enum":["01","02","03","04"],"description":"(aka threeDSRequestorChallengeInd in EMVCo specifications) Indicates whether a challenge is requested for this transaction 01(No preference) 02(No challenge requested) 03(Challenge requested 3DSRequestor Preference) 04(Challenge requested Mandate)","example":"01"},"priorAuthenticationInfo":{"$ref":"#/definitions/ThreeDSRequestorPriorAuthenticationInfo"}}},"ThreeDSRequestorAuthenticationInfo":{"type":"object","properties":{"requestAuthenticationMethod":{"type":"string","enum":["01","02","03","04","05","06"],"description":"(aka threeDSReqAuthMethod in EMVCo specification) Mechanism used by the Cardholder to authenticate to the 3DS Requestor. 01(No 3DS Requestor authentication occurred) 02(Login to the cardholder account at the 3DS Requestor system using 3DS Requestor’s own credentials) 03(Login to the cardholder account at the 3DS Requestor system using federated ID) 04(Login to the cardholder account at the 3DS Requestor system using issuer credentials) 05(Login to the cardholder account at the 3DS Requestor system using third-party authentication) 06(Login to the cardholder account at the 3DS Requestor system using FIDO Authenticator)","example":"03"},"requestAuthenticationTimestamp":{"type":"string","format":"date-time","description":"(aka threeDSReqAuthTimestamp in EMVCo specification) Date and time in UTC of the cardholder authentication.","example":"2017-07-21T17:32:28Z"}}},"ThreeDSRequestorPriorAuthenticationInfo":{"type":"object","properties":{"requestAuthenticationMethod":{"type":"string","enum":["01","02","03","04"],"description":"Indicates the type of Authentication request 01(Frictionless authentication occurred by ACS) 02(Cardholder challenge occurred by ACS) 03(AVS verified) 04(Other issuer methods)","example":"02"},"requestPriorAuthenticationTimestamp":{"type":"string","format":"date-time","description":"Date and time in UTC of the prior cardholder authentication.","example":"2017-07-21T17:32:28Z"}}},"CardHolderAccountInfo":{"type":"object","properties":{"ageIndicator":{"type":"string","enum":["01","02","03","04","05"],"description":"(aka chAccAgeInd in EMVCo specifications) Length of time that the cardholder has had the account with the 3DS Requestor. 01(No account (guest check-out)) 02(Created during this transaction) 03(Less than 30 days) 04(30−60 days) 05(More than 60 days)","example":"03"},"change":{"type":"string","format":"date","description":"(aka chAccChange in EMVCo specifications) Date that the cardholder’s account with the 3DS Requestor was last changed.","example":"2018-09-02"},"changeIndicator":{"type":"string","enum":["01","02","03","04"],"description":"(aka chAccChangeInd in EMVCo specifications) Length of time since the cardholder’s account information was last changed 01(Created during this transaction) 02(Less than 30 days) 03(30-60 days) 04(More than 60 day)","example":"01"},"creationDate":{"type":"string","format":"date","description":"(aka chAccDate in EMVCo specifications) Date that the cardholder opened the account with the 3DS Requestor.","example":"2018-09-25"},"passwordChange":{"type":"string","format":"date","description":"(aka chAccPwChange in EMVCo specifications) Date that cardholder’s account with the 3DS Requestor had a password change or account reset.","example":"2018-09-25"},"passwordChangeIndicator":{"type":"string","enum":["01","02","03","04","05"],"description":"(aka chAccPwChangeInd in EMVCo specifications) Indicates the length of time since the cardholder’s account with the 3DS Requestor had a password change or account reset. 01(No change) 02(Created during this transaction) 03(Less than 30 days) 04(30−60 days) 05(More than 60 days)","example":"02"},"purchaseCount":{"type":"integer","minLength":1,"maxLength":4,"description":"(aka nbPurchaseAccount in EMVCo specifications) Number of purchases with this cardholder account during the previous six months.","example":"31"},"provisionAttemptsDays":{"type":"integer","minLength":1,"maxLength":3,"description":"(aka provisionAttemptsDay in EMVCo specifications) Number of Add Card attempts in the last 24 hours.","example":"1"},"transactionActivityDays":{"type":"integer","minLength":1,"maxLength":3,"description":"(aka txnActivityDay in EMVCo specifications) Number of transactions (successful and abandoned) for this cardholder account with the 3DS Requestor across all payment accounts in the previous 24 hours.","example":"46"},"transactionActivityYear":{"type":"integer","minLength":1,"maxLength":3,"description":"(aka txnActivityYear in EMVCo specifications) Number of transactions (successful and abandoned) for this cardholder account with the 3DS Requestor across all payment accounts in the previous year.","example":"23"},"paymentAccountAge":{"type":"string","format":"date","description":"(aka paymentAccAge in EMVCo specifications) Date that the payment account was enrolled in the cardholder’s account with the 3DS Requestor.","example":"2019-01-21"},"paymentAccountAgeIndicator":{"type":"string","enum":["01","02","03","04","05"],"description":"(aka paymentAccInd in EMVCo specifications) Indicates the length of time that the payment account was enrolled in the cardholder’s account with the 3DS Requestor. 01(No account (guest check-out)) 02(During this transaction) 03(Less than 30 days) 04(30−60 days) 05(More than 60 days)","example":"01"},"shippingAddressUsage":{"type":"string","description":"(aka shipAddressUsage in EMVCo specifications) Date when the shipping address used for this transaction was first used with the 3DS Requestor.","example":"2018-11-21"},"shippingAddressUsageIndicator":{"type":"string","enum":["01","02","03","04"],"description":"(aka shipNameIndicator in EMVCo specifications) Indicates when the shipping address used for this transaction was first used with the 3DS Requestor. 01(This transaction) 02(Less than 30 days) 03(30−60 days) 04(More than 60 days)","example":"01"},"shippingNameIndicator":{"type":"string","enum":["01","02"],"description":"(aka shipNameIndicator in EMVCo specifications) Indicates if the Cardholder Name on the account is identical to the shipping Name used for this transaction. 01(Account Name identical to shipping Name) 02(Account Name different than shipping Name)","example":"02"},"suspiciousAccountActivity":{"type":"string","enum":["01","02"],"description":"(aka suspiciousAccActivity in EMVCo specifications) Indicates whether the 3DS Requestor has experienced suspicious activity (including previous fraud) on the cardholder account. 01(No suspicious activity has been observed) 02(Suspicious activity has been observed)","example":"01"}}},"Merchant":{"type":"object","properties":{"categoryCode":{"type":"string","minLength":4,"maxLength":4,"description":"(aka mcc in EMVCo specifications) DS-specific code describing the Merchant’s type of business, product or service."},"countryCode":{"type":"string","minLength":3,"maxLength":3,"description":"(aka merchantCountryCode in EMVCo specifications)Country Code of the Merchant."},"name":{"type":"string","maxLength":40,"description":"(aka merchantName in EMVCo specifications) Merchant name assigned by the Acquirer or Payment System."},"riskIndicator":{"$ref":"#/definitions/MerchantRiskIndicator"}}},"MerchantRiskIndicator":{"type":"object","properties":{"deliveryEmailAddress":{"type":"string","maxLength":254,"description":"For Electronic delivery, the email address to which the merchandise was delivered.","example":"john.doe@example.it"},"deliveryTimeframe":{"type":"string","enum":["01","02"],"description":"Indicates the merchandise delivery timeframe. 01(Electronic Delivery) 02(Same day shipping) 03(Overnight shipping) 04(Two-day or more shipping)","example":"01"},"giftCardAmount":{"type":"string","maxLength":15,"description":"For prepaid or gift card purchase, the purchase amount total of prepaid or gift card(s) in major units (for example, USD 123.45 is 123).","example":"12345"},"giftCardCount":{"type":"string","minLength":2,"maxLength":2,"description":"For prepaid or gift card purchase, total count of individual prepaid or gift cards/codes purchased."},"giftCardCurrency":{"type":"string","minLength":3,"maxLength":3,"description":"(aka giftCardCurr in EMVCo specifications) For prepaid or gift card purchase, the currency code of the card as defined in ISO 4217","example":"978"},"preOrderDate":{"type":"string","format":"date","description":"For a pre-ordered purchase, the expected date that the merchandise will be available.","example":"2018-07-07"},"preOrderPurchaseIndicator":{"type":"string","description":"(aka preOrderPurchaseInd in EMVCo specifications) Indicates whether Cardholder is placing an order for merchandise with a future availability or release date. 01(Merchandise available) 02(Future availability)","enum":["01","02"],"example":"01"},"reorderItemsIndicator":{"type":"string","description":"(aka reorderItemsInd in EMVCo specifications) Indicates whether the cardholder is reordering previously purchased merchandise. 01(First time ordered) 02(Reordered)","enum":["01","02"],"example":"01"},"shipIndicator":{"type":"string","enum":["01","02","03","04","05","06","07"],"description":"Indicates shipping method chosen for the transaction.\n  01(Ship to cardholder’s billing address)\n  02(Ship to another verified address on file with merchant)\n  03(Ship to address that is different than the cardholder’s billing address)\n  04(Ship to Store” / Pick-up at local store)\n  05(Digital goods)\n  06(Travel and Event tickets, not shipped)\n  07(Other)","example":"01"}}},"PlainCard":{"description":"Object contains  payment instrument data","type":"object","required":["pan","expDate"],"properties":{"pan":{"type":"string","minLength":13,"maxLength":19,"description":"(aka acctNumber on EMVCO documentation) Pan account number","example":"4012001037141112"},"expDate":{"type":"string","minLength":4,"maxLength":4,"description":"(aka cardExpiryDate on EMVCO documentation) Card Expiration Date in yyMM format","example":"1910"},"cardholderName":{"type":"string","minLength":1,"maxLength":255,"description":"Card Holder Name","example":"Surname,Name"},"accountType":{"type":"string","enum":["01","02","03"],"description":"(aka acctType on EMVCO documentation) Account Type. For example, for a multi-account card product 01(Not Applicable) 02(Credit) 03(Debit)","example":"01"}}},"CardHolder":{"type":"object","description":"Object contains buyer properties","required":["email"],"properties":{"email":{"type":"string","description":"Buyer Email","minLength":1,"maxLength":256,"example":"john.doe@email.com"},"msisdn":{"type":"string","minLength":1,"maxLength":16,"description":"(aka mobilePhone on EMVCO documentation) Mobile Phone","example":"+391231234567","pattern":"^(\\+)([0-9]{10,15})$"},"homePhone":{"type":"string","minLength":1,"maxLength":16,"description":"Home Phone","example":"+391231234567","pattern":"^(\\+)([0-9]{10,15})$"},"workPhone":{"type":"string","minLength":1,"maxLength":16,"description":"Work Phone","example":"+391231234567","pattern":"^(\\+)([0-9]{10,15})$"},"accountId":{"type":"string","description":"(aka acctID on EMVCO documentation) Cardholder Account Id","minLength":1,"maxLength":32,"example":"123455-0233939"},"shippingAddress":{"$ref":"#/definitions/Address"},"billingAddress":{"$ref":"#/definitions/Address"}}},"Address":{"type":"object","required":["city","countryCode","street","postalCode","stateCode"],"properties":{"city":{"type":"string","description":"Address City","minLength":1,"maxLength":40,"example":"Assago"},"countryCode":{"type":"string","description":"ISO 3166-1 alpha-3 Address Country Code","minLength":3,"maxLength":3,"example":"ITA"},"street":{"type":"string","description":"Address Line 1","minLength":1,"maxLength":50,"example":"strada 4"},"street2":{"type":"string","description":"Address Line 2","minLength":1,"maxLength":50,"example":"palazzo a5"},"street3":{"type":"string","description":"Address Line 3","minLength":1,"maxLength":50,"example":"milanofiori"},"postalCode":{"type":"string","description":"Address Postal Code","minLength":1,"maxLength":8,"example":"20090"},"stateCode":{"type":"string","description":"Address State/Province Code","minLength":1,"maxLength":2,"example":"MI"}}},"Purchase":{"type":"object","properties":{"amount":{"type":"integer","minLength":1,"maxLength":48,"description":"(aka purchaseAmount on EMVCO documentation) Purchase amount in minor units of currency with all punctuation removed."},"currency":{"type":"string","minLength":3,"maxLength":3,"description":"(aka purchaseCurrency on EMVCO documentation) Currency in which purchase amount is expressed."},"exponent":{"type":"integer","minLength":1,"maxLength":1,"description":"(aka purchaseExponent on EMVCO documentation)Minor units of currency as specified in the ISO 4217 currency exponent."},"date":{"type":"string","format":"date-time","description":"(aka purchaseDate on EMVCO documentation) Date and time of the purchase, expressed in UTC.","example":"2017-07-21T17:32:28Z"}}},"UserInterfaceInformation":{"type":"object","properties":{"key":{"type":"string"},"value":{"type":"string"}}},"Step":{"type":"object","required":["authenticationType"],"properties":{"authenticationType":{"type":"string","description":"Indicates whether a transaction qualifies as an authenticated transaction or account verification.","example":"OTP(One Time Password authentication) OOB(Out of band authentication) NONE(No authentication type to provide. Used only for FRICTIONLESS, DENIED and REJECTED status) CHOICE(A choice is required from the user to complete the authentication)"},"choiceCode":{"type":"string","description":"Describe the choice to be made (set to \"NONE\" if \"authenticationType\" is not \"CHOICE\")."},"step":{"type":"integer","description":"Describe the current step number in the actual authentication flow. In case of a multi-factor authentication, indicates the execution order of the authentication system. Initial value is 1."}}}}}